<template>
    <div>
        <div class="tree-item" @click.stop="openChildren = !openChildren" v-if="item.children && item.children.length > 0">
            <div class="tree-item-title" :class="{open: openChildren}">
                <div class="padding-block" v-for="(block, index) in (padding - 1)" :block="block" :key="index"></div>
                <div class="title group" :style="'width: calc(100% - ' + (padding - 1) * 30 + 'px)'"> <i class="icon chevron-right -gray-slate" v-if="!openChildren"/> <i class="icon chevron-down" v-if="openChildren"/> {{ item.path.substring(item.path.lastIndexOf('.') + 1, item.path.length) }} - {{item.denomination}}</div>
            </div>
            <div class="children" v-if="openChildren">
                <tree-item
                        :padding="padding + 1"
                        @selected="select"
                        :opening="opening"
                        v-for="(child, index) in item.children"
                        :item="child"
                        :selectedUuid="selectedUuid"
                        :index-item="index"
                        :parent="item"
                        :key="index"
                ></tree-item>
            </div>
        </div>
        <div class="tree-item-title" :class="{selection: item.uuid === selectedUuid}" v-if="!item.children || item.children.length === 0" @click.stop="$emit('selected', item, parent, indexItem)">
            <div class="padding-block" v-for="(block, index) in (padding - 1)" :block="block" :key="index"></div>
            <div class="title child" :style="'width: calc(100% - ' + (padding - 1) * 30 + 'px)'"><span class="tree-item-title__code">{{item.code}} </span> {{item.denomination}}</div>
        </div>
    </div>
</template>

<script>
    export default {
        name: "TreeItem",
        props: {
            padding: {
                type: Number,
                default: null
            },
            item: {
                type: Object,
                default: () => {}
            },
            parent: {
                type: Object,
                default: () => {}
            },
            selectedUuid: {
                type: String,
                default: ''
            },
            opening: {
                type: Boolean,
                default: false
            },
            indexItem: {
                type: Number,
                default: null
            }
        },
        data() {
            return {
                openChildren: this.opening
            }
        },
        methods: {
            select(item, parent, index) {
                this.$emit('selected', item, parent, index)
            }
        }
    }
</script>
 